/*#######################################################################################
AVR Small Webserver

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#include "main.h"
#include "rtl8019.h"
#include "arp.h"
#include "ip.h"
#include "tcp.h"


//Globale Variablen
unsigned long Seq_counter;
unsigned long Ack_counter;

struct TCP_Socket tcpsockets[Max_TCP_Sockets]; //Feld mit Max_TCP_Sockets Sockets
struct TCP_Socket *tcp_socket;                 //Pointer auf einen TCP_Socket
extern char szTelnetBuffer[35]; 	///< used as data source for tcp client

PGM_P pointerold;

unsigned int sitecounter=0;


/** \brief Get seq and ack numbers, update seq
*/
void tcp_store (char *buffer)
{
    unsigned int result16;
    struct TCP_Header *tcp;
    tcp = (struct TCP_Header *)&buffer[TCP_OFFSET];

    //Store seq number to Seq_counter
    Seq_counter = (tcp->TCP_Seqnum[0] << 8)+tcp->TCP_Seqnum[1];
    Seq_counter = Seq_counter << 16;
    Seq_counter = Seq_counter +(unsigned int) ((tcp->TCP_Seqnum[2] << 8)
                  +tcp->TCP_Seqnum[3]);

    //Store ack number to ACK_counter
    Ack_counter = (tcp->TCP_Acknum[0] << 8)+tcp->TCP_Acknum[1];
    Ack_counter = Ack_counter << 16;
    Ack_counter = Ack_counter +(unsigned int) ((tcp->TCP_Acknum[2] << 8)
                  +tcp->TCP_Acknum[3]);

    //Calculate next seq number
    if ((tcp->TCP_HdrFlags[1] & FIN_FLAG) == 0)
    {
        result16 = (buffer[IP_PKTLEN]<<8) + buffer[IP_PKTLEN+1];
        result16 = result16 - ((buffer[IP_VERS_LEN] & 0x0F) << 2)
                   - ((buffer[TCP_HDRFLAGS] & 0xF0) >>2);

        if ((buffer[TCP_HDRFLAGS+1]&SYN_FLAG) > 0
                && result16 == 0)
        {
            result16 = 1;
        }
        Seq_counter =Seq_counter + result16;
    }
    return;
}

/** \brief Add data (static or dynamic page from PGM memory) to TCP frame buffer
*/
unsigned char tcp_add_data (PGM_P pointer,char *buffer,int *bufferlen)
{
    unsigned int result16;
    unsigned char Data = 1;
    unsigned char Buffer_Full = 0;

    //Errechnet startpunkt der Daten im Tcp buffer
    //IP Headerlnge + TCP Headerlnge + Ethernetframe
    result16 = ((buffer[IP_VERS_LEN] & 0x0F) << 2) +
               ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;

    for (;;)
    {
        Data = pgm_read_byte_near(pointer++);
        buffer[result16] = Data;
        result16++;
        //sind die daten lnger als ein Ethernetbuffer dann abbruch
        if (result16 >  (MTU_SIZE - 1))
        {
            Buffer_Full = 1;
            //Speichern des Pointers
            pointerold = pointer;
            //Abbruch der Schleife
            break;
        }

        //% bedeutet es kommt evt. was besonderes!
        if (pgm_read_byte(pointer) =='%')
        {
            // Wird VA1 gefunden %VA1 Variable1 einfgen
            if (strncmp_P("VA1",(pointer+1),3) == 0)
            {
                pointer++; //don't show "%VA1"
                pointer++; //don't show "%VA1"
                pointer++; //don't show "%VA1"
                pointer++; //don't show "%VA1"

                unsigned int tmp=sitecounter;
                char counter[5];

                for (unsigned char i=0; i<5; i++)
                {
                    counter[i] = (unsigned char)(tmp%10) + '0';
                    tmp/=10;
                }

                for (unsigned char i=0; i<5; i++)
                {
                    buffer[result16] = counter[4-i];
                    result16++;
                }
                sitecounter++;
            }

            else if (strncmp_P("VA2",(pointer+1),3) == 0)
            {
                pointer++; //don't show "%VA1"
                pointer++; //don't show "%VA1"
                pointer++; //don't show "%VA1"
                pointer++; //don't show "%VA1"

                //unsigned int tmp=temperatura;
                //char counter[5];
                uint32_t napiecie;
                uint8_t wynik =0;
                ADCSRA |= (1<<ADSC);        	//wykonanie pojedynczej konwersji
                while (!(ADCSRA & 0x10)); // oczekiwanie na zakonczenie konwersji, ustawienie flagi ADIF
                wynik = ADCL;   	        // odczyt rejestru ADCL, konieczny mimo i wartosc jest ignorowana
                napiecie = ADCH;				// odczyt ADCH, nadpisanie zmiennej
                napiecie=napiecie*1000*5/256;
                char bufor[15],bufor2[15];
                itoa(napiecie/1000,bufor,10);
                strcat(bufor,".");
                itoa(napiecie%1000,bufor2,10);
                if (strlen(bufor2)==1) strcat(bufor,"00");
                if (strlen(bufor2)==2) strcat(bufor,"0");
                strcat(bufor,bufor2);

                for (unsigned char i=0; i<strlen(bufor); i++)
                {
                    buffer[result16] = bufor[i];
                    result16++;
                }
            }

			else if (strncmp_P("VA3",(pointer+1),3) == 0)
            {
                pointer++; //don't show "%VA3"
                pointer++; //don't show "%VA3"
                pointer++; //don't show "%VA3"
                pointer++; //don't show "%VA3"

                char bufor[5];
                itoa(strlen(szTelnetBuffer)+4,bufor,10);	//s=, %VA3, \r\n => strlen+4
                for (unsigned char i=0; i<strlen(bufor); i++)
                {
                    buffer[result16] = bufor[i];
                    result16++;
                }
            }

			else if (strncmp_P("VA4",(pointer+1),3) == 0)
            {
                pointer++; //don't show "%VA4"
                pointer++; //don't show "%VA4"
                pointer++; //don't show "%VA4"
                pointer++; //don't show "%VA4"

                for (unsigned char i=0; i<strlen(szTelnetBuffer); i++)
                {
                    buffer[result16] = szTelnetBuffer[i];
                    result16++;
                }
            }

            //Abbruch wenn %END erreicht wurde
            else if (strncmp_P("END",(pointer+1),3) == 0)
            {
                //Wait a short Time
                for (int a = 0;a<1000;a++)
                {
                    nop();
                };
                break;
            }
        }
    }
    TCP_New_Packtlen (buffer,bufferlen,result16);
    return(Buffer_Full);
}

/** \brief Add string to TCP packet data buffer
*/
char tcp_add_datastring (char *pointer,char *buffer,int *bufferlen)
{
    //Variablen Fr die Routine
    unsigned int result16;
    unsigned char Data = 1;
    unsigned char Buffer_Full = 0;


    //Errechnet startpunkt der Daten im Tcp buffer
    //IP Headerlnge + TCP Headerlnge + Ethernetframe
    result16 = ((buffer[IP_VERS_LEN] & 0x0F) << 2) +
               ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;

    for (;;)
    {
        Data = *pointer++;
        buffer[result16] = Data;
        result16++;
        //sind die daten lnger als ein Ethernetbuffer dann abbruch
        if (result16 >  (MTU_SIZE - 1))
        {
            Buffer_Full = 1;
            break;
        }
        //Abbruch wenn 0 erreicht wurde
        if (*pointer == 0)
        {
            //Wait a short Time
            for (int a = 0;a<1000;a++)
            {
                nop();
            };
            break;
        }
    }
    TCP_New_Packtlen (buffer,bufferlen,result16);
    return(Buffer_Full);
}

//############################################################################
//
void TCP_New_Packtlen (char *buffer,int *bufferlen,unsigned int result16)
//############################################################################
{
    //addiert noch bufferheader zur neuen ethernetlnge
    result16 = result16 + 4;
    *bufferlen = result16;
    //Errechnet die neue ip bufferlnge aus Ethernet Lnge
    //Ethernetframe - bufferheader
    result16 = result16 - 18;
    //schreibt neue IPlnge ins buffer (ip_pktlenH)
    buffer[IP_PKTLEN] = ((result16 & 0xFF00) >> 8);
    //schreibt neue IPlnge ins buffer (ip_pktlenL)
    buffer[IP_PKTLEN+1] = (result16 & 0x00FF);
    return;
}

//############################################################################
//
void tcp_make (char *buffer)
//############################################################################
{
    unsigned int result16;
    unsigned long result32 = 0x00000000;
    unsigned char DataH;
    unsigned char DataL;

    //Schreibt neuen seq und Ack Counter
    buffer[TCP_ACKNUM] = (Seq_counter & 0xFF000000) >> 24;
    buffer[TCP_ACKNUM+1] = (Seq_counter & 0x00FF0000) >> 16;
    buffer[TCP_ACKNUM+2] = (Seq_counter & 0x0000FF00) >> 8;
    buffer[TCP_ACKNUM+3] = Seq_counter & 0x000000FF;

    buffer[TCP_SEQNUM] = (Ack_counter & 0xFF000000) >> 24;
    buffer[TCP_SEQNUM+1] = (Ack_counter & 0x00FF0000) >> 16;
    buffer[TCP_SEQNUM+2] = (Ack_counter & 0x0000FF00) >> 8;
    buffer[TCP_SEQNUM+3] = Ack_counter & 0x000000FF;

    //change source port to dest port and vice versa
    DataH = buffer[TCP_SRCPORT];
    buffer[TCP_SRCPORT] = buffer[TCP_DESTPORT];
    buffer[TCP_DESTPORT] = DataH;
    DataL = buffer[TCP_SRCPORT+1];
    buffer[TCP_SRCPORT+1] = buffer[TCP_DESTPORT+1];
    buffer[TCP_DESTPORT+1] = DataL;

    //set MAC and IP numbers to reply
    Make_IP_Header(buffer, 1);

    //Berechnung der TCP Checksumme
    //Alle Daten im TCP Header werden addiert checksum wird deshalb
    //ersteinmal auf null gesetzt
    buffer[TCP_CHKSUM] = 0x00;
    buffer[TCP_CHKSUM+1] = 0x00;

    //Berechnet Headerlnge und Addiert Pseudoheaderlnge 2XIP = 8
    result16 = (buffer[IP_PKTLEN]<<8) + buffer[IP_PKTLEN+1] + 8;
    result16 = result16 - ((buffer[IP_VERS_LEN] & 0x0F) << 2);
    result32 = result16 - 2;

    //Pointer wird auf das erste buffer im IP Header gesetzt
    //Routine berechnet die Checksumme
    result16 = checksum (&buffer[IP_SRCADDR], result16, result32);

    //schreibt checksum ins buffer (INT H Byte)
    buffer[TCP_CHKSUM] = ((result16 & 0xFF00) >> 8);

    //schreibt checksum ins buffer (INT L Byte)
    buffer[TCP_CHKSUM+1] = (result16 & 0x00FF);

    //Habe Fertig!!
}


//############################################################################
//
void tcp_make_client (char *buffer)
//############################################################################
{
    unsigned int result16;
    unsigned long result32 = 0x00000000;
/*
    unsigned char DataH;
    unsigned char DataL;

    //Schreibt neuen seq und Ack Counter
    buffer[TCP_ACKNUM] = (Seq_counter & 0xFF000000) >> 24;
    buffer[TCP_ACKNUM+1] = (Seq_counter & 0x00FF0000) >> 16;
    buffer[TCP_ACKNUM+2] = (Seq_counter & 0x0000FF00) >> 8;
    buffer[TCP_ACKNUM+3] = Seq_counter & 0x000000FF;

    buffer[TCP_SEQNUM] = (Ack_counter & 0xFF000000) >> 24;
    buffer[TCP_SEQNUM+1] = (Ack_counter & 0x00FF0000) >> 16;
    buffer[TCP_SEQNUM+2] = (Ack_counter & 0x0000FF00) >> 8;
    buffer[TCP_SEQNUM+3] = Ack_counter & 0x000000FF;

    //change source port to dest port and vice versa
    DataH = buffer[TCP_SRCPORT];
    buffer[TCP_SRCPORT] = buffer[TCP_DESTPORT];
    buffer[TCP_DESTPORT] = DataH;
    DataL = buffer[TCP_SRCPORT+1];
    buffer[TCP_SRCPORT+1] = buffer[TCP_DESTPORT+1];
    buffer[TCP_DESTPORT+1] = DataL;
*/

    //set MAC and IP numbers to reply
    Make_IP_Header(buffer, 0);

    //Berechnung der TCP Checksumme
    //Alle Daten im TCP Header werden addiert checksum wird deshalb
    //ersteinmal auf null gesetzt
    buffer[TCP_CHKSUM] = 0x00;
    buffer[TCP_CHKSUM+1] = 0x00;

    //Berechnet Headerlnge und Addiert Pseudoheaderlnge 2XIP = 8
    result16 = (buffer[IP_PKTLEN]<<8) + buffer[IP_PKTLEN+1] + 8;
    result16 = result16 - ((buffer[IP_VERS_LEN] & 0x0F) << 2);
    result32 = result16 - 2;

    //Pointer wird auf das erste buffer im IP Header gesetzt
    //Routine berechnet die Checksumme
    result16 = checksum (&buffer[IP_SRCADDR], result16, result32);

    //schreibt checksum ins buffer (INT H Byte)
    buffer[TCP_CHKSUM] = ((result16 & 0xFF00) >> 8);

    //schreibt checksum ins buffer (INT L Byte)
    buffer[TCP_CHKSUM+1] = (result16 & 0x00FF);

    //Habe Fertig!!
}



/** \brief Send packet with ACK, FIN, PUSH (ack connection close to 2nd party)
*/
void TCP_PORT_CLOSE (char *buffer,int *bufferlen)
{
    //get seq and ack numbers
    tcp_store(buffer);
    //set FIN Flag
    buffer[TCP_HDRFLAGS+1] = ACK_FLAG | FIN_FLAG | PSH_FLAG;

    //Erzeugt ein TCP buffer
    tcp_make(buffer);
    //Sendet das erzeugte TCP buffer
    Write_Ethernet_Frame (buffer,*bufferlen);
}


/** \brief
	\return 1 if TCP connection is opening or closing, 0 elsewhere
*/
int TCP_OPEN (char *buffer,int *bufferlen)
{
    unsigned int tcp_srcport;
    tcp_srcport=(buffer[TCP_SRCPORT]<<8) + buffer[TCP_SRCPORT+1];

    unsigned char tcp_hdrflags1=buffer[TCP_HDRFLAGS+1];

    if ((tcp_hdrflags1 & SYN_FLAG) > 0
            && (tcp_hdrflags1 & (PSH_FLAG | ACK_FLAG)) == 0)
    {
        //find unused socket structure
        for (unsigned char a=0;a<Max_TCP_Sockets;a++)
        {
            tcp_socket= &tcpsockets[a]; 
            if (tcp_socket->Store == 0)
            {
                tcp_socket->Store = tcp_srcport;
                tcp_socket->Status = TCP_SOCKET_NOT_USE;
                break;
            }
        }
        //Speichert Sequenzcounter und Aknowledgecounter
        tcp_store(buffer);
        //Setzen des Ack Flag
        buffer[TCP_HDRFLAGS+1] |= ACK_FLAG;
        //Erzeugt ein TCP buffer
        tcp_make(buffer);
        //Sendet das erzeugte TCP buffer
        Write_Ethernet_Frame (buffer,*bufferlen);
        return(1);
    }

	//if RST flag (forced closure) is set release socket structure
    if ((tcp_hdrflags1 & RST_FLAG) > 0)
    {
        for (unsigned char a=0;a<Max_TCP_Sockets;a++)
        {
            tcp_socket= &tcpsockets[a]; //Pointer auf tcpsockets[a] holen
            if (tcp_socket->Store == tcp_srcport)
            {
                tcp_socket->Store = 0;
                break;
            }
        }
        return(1);
    }

	//if FIN flag is set release socket structure and send ACK
    if ((tcp_hdrflags1 & FIN_FLAG) > 0)
    {
        for (unsigned char a=0;a<Max_TCP_Sockets;a++)
        {
            tcp_socket= &tcpsockets[a]; //Pointer auf tcpsockets[a] holen

            if (tcp_socket->Store == tcp_srcport)
            {
                tcp_socket->Store = 0;
                break;
            }
        }
        //Setzen des Ack Flag
        buffer[TCP_HDRFLAGS+1] = RST_FLAG;
        //Speichert Sequenzcounter und Aknowledgecounter
        tcp_store(buffer);
        //Seq_counter um 1 erhhen
        Seq_counter = Seq_counter + 1;
        //Erzeugt ein TCP buffer
        tcp_make(buffer);
        //Sendet das erzeugte TCP buffer
        Write_Ethernet_Frame (buffer,*bufferlen);
        return(1);
    }
    return(0);
}


/** \brief Menages TCP stack
	\param *buffer pointer to tcp buffer
	\param *bufferlen tcp buffer length
	\param *Stackpointer returned index of struct TCP_Socket related to frame
	\return 1 if no data has to be sent as answer
*/
char TCP_Stack (char *buffer,int *bufferlen,unsigned char *Stackpointer)
{
    if (TCP_OPEN(buffer,bufferlen)==1)
    {
        //TCP SYNC, FIN or RST found in buffer
		return(1);
    }

    unsigned int	TCP_Socket = (buffer[TCP_SRCPORT]<<8) + buffer[TCP_SRCPORT+1];

    for (unsigned char a=0;a<Max_TCP_Sockets;a++)
    {
        tcp_socket= &tcpsockets[a]; //Pointer auf tcpsockets[a] holen

        if (TCP_Socket == tcp_socket->Store)
        {
            if ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0
                    && (tcp_socket->Status == TCP_SOCKET_OPEN1 || tcp_socket->Status == TCP_SOCKET_OPEN2))
            {
                *Stackpointer = a;
                return(0); //Daten fr Anwendung
            }

            if (tcp_socket->Status == TCP_SOCKET_CLOSE)	//application layer requested socket close
            {
                tcp_socket->Store = TCP_SOCKET_NOT_USE;
                tcp_socket->Status = 0; //TCP Socket wird im TCP STACK geschlossen
                printf("TCP Socket Close Socket:%d Stack:%d\n",TCP_Socket,a);
                TCP_PORT_CLOSE (buffer,bufferlen);
                *Stackpointer = a;
                return(1); //Keine Daten fr Anwendung
            }

            if (tcp_socket->Status == TCP_SOCKET_NOT_USE)
            {
                printf("TCP Socket Open Socket:%d Stack:%d\n",TCP_Socket,a);
                tcp_socket->Status = TCP_SOCKET_OPEN1; //TCP Socket wird im TCP Stack geffnet
                *Stackpointer = a;
                return(0); //ACK fr Anwendung
            }

            if ((buffer[TCP_HDRFLAGS+1]&ACK_FLAG) > 0
                    && (tcp_socket->Status == TCP_SOCKET_OPEN1 || tcp_socket->Status == TCP_SOCKET_OPEN2))
            {
                *Stackpointer = a;
                return(0); //ACK fr Anwendung
            }
        }
    }
    return (1);
}




